SystemOrganization addCategory: #'Cutie-HelvetiaTestFixtures'!

QQTestCase subclass: #CURaisedToFixture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-HelvetiaTestFixtures'!

!CURaisedToFixture class methodsFor: 'private' stamp: 'fbs 1/2/2012 18:28'!
raise: aNode to: anInteger
	"self raise: ``(x) to: -5"

	anInteger = 0
		ifTrue: [ ^ ``1 ].
	anInteger = 1
		ifTrue: [ ^ aNode ].
	anInteger < 0
		ifTrue: [ ^ ``(1 / `,(self raise: aNode to: anInteger abs)) ].
	^ ``(`,(self raise: aNode to: anInteger abs - 1) * `,aNode)! !

!CURaisedToFixture class methodsFor: 'transformations' stamp: 'fbs 1/2/2012 18:26'!
transformRaisedTo
	<transform>

	^ CHTreePattern new
		expression: '`@source raisedTo: `#literal' do: [ :context |
			context node swapWith: (self 
				raise: context node receiver
				to: context node arguments first value) ];
		yourself! !

Object subclass: #CH2EbnfNumberParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-HelvetiaTestFixtures'!

!CH2EbnfNumberParser class methodsFor: 'instance-creation' stamp: 'lr 9/23/2010 22:09'!
debug
	| parser process |
	parser := self new.
	process := [ parser number ]
		newProcess.
	4 timesRepeat: [ process step ].
	Debugger
		openProcess: process
		context: process suspendedContext! !

!CH2EbnfNumberParser class methodsFor: 'instance-creation' stamp: 'lr 9/23/2010 22:10'!
parse: aString
	^ self new number parse: aString! !

PPCompositeParser subclass: #CH1EbnfGrammar
	instanceVariableNames: 'rule identifier definition expression list separation term option optionOpen optionClose repetition repetitionOpen repetitionClose grouping groupingOpen groupingClose string terminator terminal nonterminal production'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-HelvetiaTestFixtures'!

!CH1EbnfGrammar methodsFor: 'token' stamp: 'lr 9/23/2010 22:01'!
definition
	^ $= asParser token trim! !

!CH1EbnfGrammar methodsFor: 'grammar' stamp: 'lr 6/16/2008 10:21'!
expression
	^ list separatedBy: separation! !

!CH1EbnfGrammar methodsFor: 'grammar' stamp: 'lr 6/16/2008 10:31'!
grouping
	^ groupingOpen , expression , groupingClose! !

!CH1EbnfGrammar methodsFor: 'token' stamp: 'lr 9/23/2010 22:01'!
groupingClose
	^ $) asParser token trim! !

!CH1EbnfGrammar methodsFor: 'token' stamp: 'lr 9/23/2010 22:01'!
groupingOpen
	^ $( asParser token trim! !

!CH1EbnfGrammar methodsFor: 'token' stamp: 'lr 9/23/2010 22:01'!
identifier
	^ #letter asParser plus token trim! !

!CH1EbnfGrammar methodsFor: 'grammar' stamp: 'lr 6/16/2008 10:42'!
list
	^ term plus! !

!CH1EbnfGrammar methodsFor: 'grammar' stamp: 'lr 6/16/2008 11:11'!
nonterminal
	^ identifier! !

!CH1EbnfGrammar methodsFor: 'grammar' stamp: 'lr 6/16/2008 10:30'!
option
	^ optionOpen , expression , optionClose! !

!CH1EbnfGrammar methodsFor: 'token' stamp: 'lr 9/23/2010 22:01'!
optionClose
	^ $] asParser token trim! !

!CH1EbnfGrammar methodsFor: 'token' stamp: 'lr 9/23/2010 22:01'!
optionOpen
	^ $[ asParser token trim! !

!CH1EbnfGrammar methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:24'!
production
	^ PPSmalltalkGrammar newStartingAt: #startExpression! !

!CH1EbnfGrammar methodsFor: 'grammar' stamp: 'lr 6/16/2008 10:31'!
repetition
	^ repetitionOpen , expression , repetitionClose! !

!CH1EbnfGrammar methodsFor: 'token' stamp: 'lr 9/23/2010 22:01'!
repetitionClose
	^ $} asParser token trim! !

!CH1EbnfGrammar methodsFor: 'token' stamp: 'lr 9/23/2010 22:01'!
repetitionOpen
	^ ${ asParser token trim! !

!CH1EbnfGrammar methodsFor: 'grammar' stamp: 'lr 7/4/2008 11:44'!
rule
	^ identifier , definition , expression , terminator , production! !

!CH1EbnfGrammar methodsFor: 'token' stamp: 'lr 9/23/2010 22:01'!
separation
	^ $| asParser token trim! !

!CH1EbnfGrammar methodsFor: 'accessing' stamp: 'lr 6/18/2008 08:43'!
start
	^ rule end! !

!CH1EbnfGrammar methodsFor: 'token' stamp: 'lr 9/23/2010 22:01'!
string
	^ ($" asParser , $" asParser negate star , $" asParser) token trim
	/  ($' asParser , $' asParser negate star , $' asParser) token trim! !

!CH1EbnfGrammar methodsFor: 'grammar' stamp: 'lr 12/2/2008 11:13'!
term
	^ option / repetition / grouping / terminal / nonterminal! !

!CH1EbnfGrammar methodsFor: 'grammar' stamp: 'lr 6/16/2008 11:12'!
terminal
	^ string! !

!CH1EbnfGrammar methodsFor: 'token' stamp: 'lr 9/23/2010 22:01'!
terminator
	^ $; asParser token trim! !

CH1EbnfGrammar subclass: #CH1EbnfHighlighter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-HelvetiaTestFixtures'!

!CH1EbnfHighlighter methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:41'!
nonterminal
	^ super nonterminal ==> [ :node | node -> Color green muchDarker ]! !

!CH1EbnfHighlighter methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:32'!
production
	"We don't have Smalltalk highlighting for now."

	^ #any asParser star! !

!CH1EbnfHighlighter methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:42'!
terminal
	^ super terminal ==> [ :node | node -> Color blue ]! !

CH1EbnfGrammar subclass: #CH1EbnfParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Cutie-HelvetiaTestFixtures'!

!CH1EbnfParser methodsFor: 'grammar' stamp: 'lr 12/2/2008 14:15'!
expression
	^ super expression ==> [ :nodes |
		nodes allButFirst
			inject: nodes first
			into: [ :result :each |
				(each isKindOf: RBProgramNode)
					ifTrue: [
						RBMessageNode
							receiver: result selector: #/
							arguments: (Array with: each) ]
					ifFalse: [ result ] ] ]! !

!CH1EbnfParser methodsFor: 'grammar' stamp: 'lr 6/16/2008 15:58'!
grouping
	^ super grouping ==> #second! !

!CH1EbnfParser methodsFor: 'grammar' stamp: 'lr 6/16/2008 11:05'!
list
	^ super list ==> [ :nodes | 
		nodes allButFirst
			inject: nodes first
			into: [ :result :each |
				RBMessageNode
					receiver: result selector: #,
					arguments: (Array with: each) ] ]! !

!CH1EbnfParser methodsFor: 'grammar' stamp: 'lr 6/16/2008 11:13'!
nonterminal
	^ super nonterminal ==> [ :token |
		RBMessageNode new
			receiver: (RBVariableNode named: 'self')
			selectorParts: (Array with: token)
			arguments: #() ]! !

!CH1EbnfParser methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:30'!
option
	^ super option ==> [ :nodes | 
		(RBMessageNode receiver: nodes second selector: #optional)
			rangeStart: nodes first start;
			rangeStop: nodes last stop;
			yourself ]! !

!CH1EbnfParser methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:25'!
production
	^ (PPSmalltalkParser newStartingAt: #startExpression) ==> [ :node |
		RBBlockNode
			arguments: (Array with: (RBVariableNode named: 'node'))
			body: node ]! !

!CH1EbnfParser methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:30'!
repetition
	^ super repetition ==> [ :nodes | 
		(RBMessageNode receiver: nodes second selector: #star)
			rangeStart: nodes first start;
			rangeStop: nodes last stop;
			yourself ]! !

!CH1EbnfParser methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:26'!
rule
	^ super rule ==> [ :nodes | 
		RBMethodNode new
			selectorParts: (Array with: nodes first)
			arguments: Array new;
			body: (RBSequenceNode new
				statements: (Array 
					with: (nodes fifth body statements isEmpty
						ifTrue: [ nodes third ]
						ifFalse: [
							RBMessageNode
								receiver: nodes third selector: #==>
								arguments: (Array with: nodes fifth) ]));
				addReturn;
				yourself);
			source: nodes second collection;
			yourself ]! !

!CH1EbnfParser methodsFor: 'grammar' stamp: 'lr 9/23/2010 22:28'!
terminal
	| cropped |
	^ super terminal ==> [ :token |
		cropped := token value 
			copyFrom: 2 to: token size - 1.
		RBMessageNode
			receiver: (RBLiteralNode literalToken: (cropped size = 1
				ifTrue: [ RBNumberLiteralToken value: cropped first start: token start stop: token stop source: token value ]
				ifFalse: [ RBNumberLiteralToken value: cropped start: token start stop: token stop source: token value ]))
			selector: #asParser ]! !
